;**********************************************************************;
;*                                AERO                                *;
;*--------------------------------------------------------------------*;
;**********************************************************************;

;== Constantes =========================================================

SC_INDEX       = 3c4h     ;Registre d'index du contrleur du squenceur.
SC_MAP_MASK    = 2                          ;Numro du registre Map-Mask
SC_MEM_MODE    = 4                   ;Numro du registre de mode mmoire

GC_INDEX       = 3ceh          ;Registre d'index du contrleur graphique
GC_FN_SELECT   = 3          ;Numro du registre de slection de fonction
GC_READ_MAP    = 4                          ;Numro du registre Read Map
GC_GRAPH_MODE  = 5                 ;Numro du registre de mode graphique
GC_MISCELL     = 6                            ;Numro du registre divers
GC_BIT_MASK    = 8                 ;Numro du registre de masque binaire

CRTC_INDEX     = 3d4h            ;Registre d'index du contrleur d'cran
CC_MAX_SCAN    = 9     ;Numro du registre du maximum de lignes balayes
CC_START_HI    = 0Ch                        ;Numro du registre Hi_Start
CC_UNDERLINE   = 14h                 ;Numro du registre de soulignement
CC_MODE_CTRL   = 17h             ;Nummer du registre de contrle de mode

DAC_WRITE_ADR  = 3C8h                                 ;Adresse DAC Write
DAC_READ_ADR   = 3C7h                                  ;Adresse DAC Read
DAC_DATA       = 3C9h                          ;Registres de donnes DAC

VERT_RETRACE   = 3DAh                    ;Registre d'tat des entres #1

incr           = 4
milx           = 320
mily           = 175
stopangle      = 360*2*incr

pllarg         = 90
pllong         = 150
lpal           = 3
maxfaces       = 45*4

mulo      =5
addo       =32

;== Donnes ============================================================

donnees    segment para 'data'

INCLUDE sin.dat
INCLUDE cos.dat
INCLUDE planche.dat
INCLUDE corresp.dat
INCLUDE palet.dat
centerx    dw 0
centery    dw 0
centerz    dw 0

    coul2  db 00,00,30
           db 00,00,30
           db 00,00,30
           db 00,00,30
           db 00,00,30
           db 00,00,35
           db 00,00,30
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
           db 00,00,60
couleur    dw 15

faces      dw maxfaces*2 dup (0)
profond    dw maxfaces*2 dup (0)

palet2d    dw 32 dup (0)        ;16*2

paletx     dw 0
palety     dw 0

positx     dw 0
posity     dw 0
pagecour   dw 1

factmul    dw 10000
Perspective   dw 256
anglex      dw 230*incr
angley     dw 360*incr

x1         dw (?)
x2         dw (?)
x3         dw (?)
x4         dw (?)
y1         dw (?)
y2         dw (?)
y3         dw (?)
y4         dw (?)
delta1     dw (?)
delta2     dw (?)
delta3     dw (?)
delta4     dw (?)
delta5     dw (?)




xdiff      dw (?)
ydiff      dw (?)
xunit      dw (?)
yunit      dw (?)
erreur     dw (?)
temp       dw (?)

vio_seg    dw (?)                           ;Segment vido page courante
largeurl   dw (?)               ;Largeur d'une ligne de pixels en octets
pageofs    dw (?)                     ;Offset de la page dans le segment

donnees    ends


;== Code ===============================================================
code       segment para 'code'

          org 100h

           assume cs:code,ds:donnees,ss:pile
debut:
           mov  ax,donnees
           mov  ds,ax

           call init640350

           mov  ah,10h              ;changement des couleurs
           mov  al,12h
           mov  bx,1
           mov  cx,16
           push ds
           pop  es
           mov  dx,offset coul2
           int  10h


           mov  ax,00h                  ;init de la souris
           int  33h

           mov  ax,08h
           mov  cx,0
           mov  dx,640
           int  33h
           mov  ax,07h
           int  33h


           mov ax,0                    
           call setpage
           call Afftable
           call affpalet


debboucle:
           mov  ah,01h
           int  16h 
           push ax
           pushf
;

           mov  ax,03h
           int  33h
           cmp bx,0b
           je  @pastable
           call  TournTabl
@pastable:


           mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet
           pop ax
           call showpage



;
           popf
           pop  ax
           jz   debboucle                 ;on a appuye sur une touche



           cmp  ah,61                     ; F3 appuye
           jne  pasf3
           mov  centerx,0                       ;centre la table
           mov  centery,0
           mov  centerz,0
           mov  Perspective,256
           mov  anglex,230
           mov  angley,360
           mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet
           pop ax
           call showpage
           mov al,26





pasf3:      cmp  ah,60                     ; F2 appuye
           jne  pasf2
           mov  centerx,0                       ;centre la table
           mov  centery,0
           mov  centerz,0
           mov  Perspective,256
           mov  anglex,230*incr
           mov  angley,360*incr
           mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet

           pop ax
           call showpage
           mov al,26


pasf2:     cmp  al,27
           mov  ah,00h
           int  16h
           je   clafin
           jmp  debboucle
clafin:


           mov  al,03h                       ;fin du prog
           mov  ah,00h
           int  10h        
           mov  ax,4c00h
           int  21h

;-----------------------------------------------------------------------------
;-- convpt:convertit un point 3d en un point 2d
;-- ax<<y      bx<<x       cx<<z   >>>>>>>>>>>>>>   ax<<y      bx<<x
convpt     proc near

           add  cx,centerz           ;(point.z+center.z)
           mov  dx,Perspective
           sub  dx,cx                ;(Perspective-(point.z+center.z))
           mov  cx,dx                ;cx : (Perspective-(point.z+center.z))

           add  ax,centery           ;(point.y+center.y)
           mov  dx,Perspective
           imul dx                   ;(Perspective*(point.y+center.y)
           idiv cx                   ;(Perspective*(point.y+center.y)
           add  ax,mily              ;  div (Perspective-(point.z+center.z)))+175
           push ax

           mov  ax,bx
           add  ax,centerx           ;(point.x+center.x)
           mov  dx,Perspective
           imul dx                   ;(Perspective*(point.x+center.x)
           idiv cx                   ;(Perspective*(point.x+center.x)
           add  ax,milx              ;  div (Perspective-(point.z+center.z)))+320

           mov  bx,ax                ;  bx <<< x
           pop  ax                   ;  ax <<< y

           ret
convpt     endp



;-----------------------------------------------------------------------------
;-- ligne:trace une ligne avec 2 points 2d
;-- ax<<y1      bx<<x1       cx<<y2    dx<<x2  

ligne     proc near

          push ax
          push bx

etap1:    cmp  ax,cx
          jg   supy2
supy1:    sub  ax,cx
          mov  ydiff,ax
          mov  yunit,1
          jmp  etap2

supy2:    sub  cx,ax
          mov  ydiff,cx
          mov  yunit,-1

etap2:    cmp  bx,dx
          jg   supx2
supx1:    sub  bx,dx
          mov  xdiff,bx
          mov  xunit,1
          jmp  etap3

supx2:    sub  dx,bx
          mov  xdiff,dx
          mov  xunit,-1

etap3:    mov  ax,xdiff
          cmp  ax,ydiff
          jg   ysupx


xsupy:    pop bx
          pop ax
          mov  cx,0
          mov  dx,1
for1:
          push ax
          push bx
          push cx
          push dx
          call setpix
          pop  dx
          pop  cx
          pop  bx
          pop  ax

          add bx,xunit
          add cx,ydiff
          cmp cx,xdiff
          jg errinf
          sub cx,xdiff

          add ax,yunit
errinf:   dec  dx
          cmp  dx,xdiff
          jne  for1

          jmp  etap5

ysupx:    pop bx
          pop ax
          mov  cx,0
          mov  dx,1
for2:
          push ax
          push bx
          push cx
          push dx
          call setpix
          pop  dx
          pop  cx
          pop  bx
          pop  ax

          add ax,yunit
          add cx,xdiff
          cmp cx,0
          jg errinf2
          sub cx,ydiff

           add bx,xunit
errinf2:  dec  dx
          cmp  dx,ydiff
          jne  for2


etap5:
          ret
ligne     endp


;-----------------------------------------------------------------------------
;-- rotatx:rotation d' un point 3d autours de l'axe x
;-- ax<<y      bx<<x       cx<<z   >>>>>>>>>>>>>>   ax<<y      bx<<x    cx<<z
rotatx     proc near
           push bx
           push ax
           push cx
           mov  di,anglex

           imul [cos + di]
           idiv word ptr factmul
           mov  bx,ax
           mov  ax,cx
           imul [sin + di]
           idiv word ptr factmul
           sub  bx,ax

           pop  cx
           pop  ax

           imul [sin + di]
           idiv word ptr factmul
           push ax
           mov  ax,cx
           imul [cos + di]
           idiv word ptr factmul
           pop  cx
           add  cx,ax

           mov  ax,bx
           pop  bx

           ret
rotatx     endp

;-----------------------------------------------------------------------------
;-- rotaty:rotation d' un point 3d autours de l'axe y
;-- ax<<y      bx<<x       cx<<z   >>>>>>>>>>>>>>   ax<<y      bx<<x    cx<<z
rotaty     proc near
           push ax
           push bx
           pop  ax
           pop  bx

           push bx
           push ax
           push cx
           mov  di,angley

           imul [cos + di]
           idiv word ptr factmul
           mov  bx,ax
           mov  ax,cx
           imul [sin + di]
           idiv word ptr factmul
           sub  bx,ax

           pop  cx
           pop  ax

           imul [sin + di]
           idiv word ptr factmul
           push ax
           mov  ax,cx
           imul [cos + di]
           idiv word ptr factmul
           pop  cx
           add  cx,ax

           pop  ax

           ret
rotaty     endp


;-----------------------------------------------------------------------------
;-- AFFpoly:affiches la table du jeu en polygones ligne

Affpoly    proc near

           mov  di,20
           mov  si,0
contpoly:
           mov  bx, coul[si]
           mov  couleur,bx
           mov  bx, faces[di]
           mov  ax, faces[di+2]
           mov  dx, faces[di+4]
           mov  cx, faces[di+6]
           push di
           call ligne
           pop  di
           mov  bx, faces[di+4]
           mov  ax, faces[di+6]
           mov  dx, faces[di+8]
           mov  cx, faces[di+10]
           push di
           call ligne
           pop  di
           mov  bx, faces[di+8]
           mov  ax, faces[di+10]
           mov  dx, faces[di+12]
           mov  cx, faces[di+14]
           push di
           call ligne
           pop  di
           mov  bx, faces[di]
           mov  ax, faces[di+2]
           mov  dx, faces[di+12]
           mov  cx, faces[di+14]
           push di
           call ligne
           pop  di

           
           add  di,16
           add  si,2
           cmp  di,16*maxfaces / 4         ;24
           jb   contpoly

           ret
affpoly    endp


;-----------------------------------------------------------------------------
;-- AFFptxy

Affptxy    proc near

            push ax
            push bx
            push cx
            push dx
            push di
            push si


            mov  ax,y1
            mov  bx,x1
            mov couleur,6
            call setpix
            mov  ax,y1
            mov  bx,x1
            inc bx
            mov couleur,6
            call setpix
            mov  ax,y1
            mov  bx,x1
            inc ax
            mov couleur,6
            call setpix
            mov  ax,y1
            mov  bx,x1
            inc ax
            inc bx
            mov couleur,6
            call setpix

            mov  ax,y2
            mov  bx,x2
            mov couleur,7
            call setpix
            mov  ax,y2
            mov  bx,x2
            inc bx
            mov couleur,7
            call setpix
            mov  ax,y2
            mov  bx,x2
            inc ax
            inc bx
            mov couleur,7
            call setpix
            mov  ax,y2
            mov  bx,x2
            inc ax
            mov couleur,7
            call setpix

            mov  ax,y3
            mov  bx,x3
            mov couleur,8
            call setpix
            mov  ax,y3
            mov  bx,x3
            inc bx
            mov couleur,8
            call setpix
            mov  ax,y3
            mov  bx,x3
            inc ax
            inc bx
            mov couleur,8
            call setpix
            mov  ax,y3
            mov  bx,x3
            inc ax
            mov couleur,8
            call setpix

            mov  ax,y4
            mov  bx,x4
            mov couleur,9
            call setpix
            mov  ax,y4
            mov  bx,x4
            inc bx
            mov couleur,9
            call setpix
            mov  ax,y4
            mov  bx,x4
            inc ax
            inc bx
            mov couleur,9
            call setpix
            mov  ax,y4
            mov  bx,x4
            inc ax
            mov couleur,9
            call setpix
            pop  si
            pop  di
            pop  dx
            pop  cx
            pop  bx
            pop  ax

            ret

affptxy     endp



;-----------------------------------------------------------------------------
;-- AFFfaces:affiches la table du jeu en faces pleines

Afffaces    proc near

           mov  di,20
           mov  si,0
contface:
;           jmp contfinfaces

           cmp si,10*2
           je contfinfaces
           cmp si,43*2
           je contfinfaces
           cmp si,14*2
           je contfinfaces
           cmp si,38*2
           je contfinfaces
           cmp si,24*2
           je contfinfaces
           cmp si,29*2
           je contfinfaces
           jmp coufaces
contfinfaces:


           mov  ax, coul[si]              ;mise en place des variables
           mov  couleur,ax
           mov  ax, faces[di]
           mov  x1, ax
           mov  ax, faces[di+2]
           mov  y1, ax
           mov  bx, faces[di+4]
           mov  x2, bx
           mov  bx, faces[di+6]
           mov  y2, bx
           mov  cx, faces[di+8]
           mov  x3, cx
           mov  cx, faces[di+10]
           mov  y3, cx
           mov  dx, faces[di+12]
           mov  x4, dx
           mov  dx, faces[di+14]
           mov  y4, dx




           cmp  ax, bx       ;determination des points les plus hauts
           jle  psup1
           push ax
           push bx
           pop  ax
           pop  bx
           push x1
           push x2
           pop  x1
           pop  x2
psup1:
           cmp  bx, cx
           jle  psup2
           push bx
           push cx
           pop  bx
           pop  cx
           push x2
           push x3
           pop  x2
           pop  x3
psup2:
           cmp  cx, dx
           jle  psup3
           push cx
           push dx
           pop  cx
           pop  dx
           push x3
           push x4
           pop  x3
           pop  x4
psup3:
           cmp  ax, bx
           jle  psup4
           push ax
           push bx
           pop  ax
           pop  bx
           push x1
           push x2
           pop  x1
           pop  x2
psup4:
           cmp  bx, cx
           jle  psup5
           push bx
           push cx
           pop  bx
           pop  cx
           push x2
           push x3
           pop  x2
           pop  x3
psup5:
           cmp  ax, bx
           jle  psup6
           push ax
           push bx
           pop  ax
           pop  bx
           push x1
           push x2
           pop  x1
           pop  x2
psup6:




           mov  y1, ax
           mov  y2, bx
           mov  y3, cx
           mov  y4, dx

           cmp  ax, bx   ;determination des coefficients directeurs
           je   delegal1
           push ax
           push bx
           push cx
           push dx

           mov  ax, x2
           sub  ax, x1
           sal ax, mulo
           cwd
           mov  cx, y2
           sub  cx, y1
           idiv cx
           mov  delta2,ax
           pop  dx
           pop  cx
           pop  bx
           pop  ax
           jmp  pdelegal1
delegal1 : mov delta2,0
pdelegal1:

           cmp  ax, cx
           je   delegal2
           push ax
           push bx
           push cx
           push dx
           mov  ax, x3
           sub  ax, x1
           sal ax, mulo
           cwd
           mov  cx, y3
           sub  cx, y1
           idiv cx
           mov  delta1,ax
           pop  dx
           pop  cx
           pop  bx
           pop  ax
           jmp  pdelegal2
delegal2 : mov delta1,0
pdelegal2:
           cmp  bx, dx
           je   delegal3
           push ax
           push bx
           push cx
           push dx
           mov  ax, x4
           sub  ax, x2
           sal ax, mulo
           cwd
           mov  cx, y4
           sub  cx, y2
           idiv cx
           mov  delta4,ax
           pop  dx
           pop  cx
           pop  bx
           pop  ax
           jmp  pdelegal3
delegal3 : mov delta4,0
pdelegal3:
           cmp  cx, dx
           je   delegal4
           push ax
           push bx
           push cx
           push dx
           mov  ax, x4
           sub  ax, x3
           sal ax, mulo
           cwd
           mov  cx, y4
           sub  cx, y3
           idiv cx
           mov  delta5,ax
           pop  dx
           pop  cx
           pop  bx
           pop  ax
           jmp  pdelegal4
delegal4 : mov delta5,0
pdelegal4:
           cmp  bx, cx
           je   delegal5
           push ax
           push bx
           push cx
           push dx
           mov  ax, x3
           sub  ax, x2
           sal ax, mulo
           cwd
           mov  cx, y3
           sub  cx, y2
           idiv cx
           mov  delta3,ax
           pop  dx
           pop  cx
           pop  bx
           pop  ax
           jmp  pdelegal5
delegal5 : mov delta3,0
pdelegal5:








           sal   x1,mulo             ;conversion pour les virgules
           sal   x2,mulo
           sal   x3,mulo
           sal   x4,mulo
           sal   y1,mulo
           sal   y2,mulo
           sal   y3,mulo
           sal   y4,mulo

            mov ax,x1                     ;triangle1 premiere partie
            mov bx,x1

            mov cx,delta1
            cmp delta2,cx
            jg  couctmp1
            jmp coucou1
couctmp1:   mov cx,y1         ;cx=y
            add cx,addo
coubou1:    add ax,delta1
            add bx,delta2
            mov dx,ax         ;dx=x
coubou12:
            push ax
            push bx
            push cx
            push dx
            mov  bx,dx
            mov  ax,cx
            sar   ax, mulo
            sar   bx, mulo
            call setpix
            pop  dx
            pop  cx
            pop  bx
            pop  ax
            add dx,addo
            cmp dx,bx
            jng coubou12
            add cx,addo
            cmp cx,y2
            jng coubou1
            jmp coucou2
coucou1:
            mov cx,y1          ;cx=y
            add cx,addo
coubou2:
            add ax,delta1
            add bx,delta2
            mov dx,bx          ;dx=x
coubou22:
            push ax
            push bx
            push cx
            push dx
            mov  bx,dx
            mov  ax,cx
            sar   ax,mulo
            sar   bx,mulo
            call setpix
            pop  dx
            pop  cx
            pop  bx
            pop  ax
            add dx,addo
            cmp dx,ax
            jng coubou22
            add cx,addo
            cmp cx,y2
            jng coubou2

coucou2:


            mov ax,x1                     ;triangle1 deuxieme partie
            mov bx,x1

            mov cx,delta1
            cmp delta2,cx
            jg  couctmp1b
            jmp coucou1b
couctmp1b:   mov cx,y2         ;cx=y
            add cx,addo
coubou1b:    add ax,delta1
            add bx,delta3
            mov dx,ax         ;dx=x
coubou12b:
            push ax
            push bx
            push cx
            push dx
            mov  bx,dx
            mov  ax,cx
            sar   ax, mulo
            sar   bx, mulo
            call setpix
            pop  dx
            pop  cx
            pop  bx
            pop  ax
            add dx,addo
            cmp dx,bx
            jng coubou12b
            add cx,addo
            cmp cx,y3
            jng coubou1b
            jmp coucou2b
coucou1b:
            mov cx,y2          ;cx=y
            add cx,addo
coubou2b:
            add ax,delta1
            add bx,delta3
            mov dx,bx          ;dx=x
coubou22b:
            push ax
            push bx
            push cx
            push dx
            mov  bx,dx
            mov  ax,cx
            sar   ax,mulo
            sar   bx,mulo
            call setpix
            pop  dx
            pop  cx
            pop  bx
            pop  ax
            add dx,addo
            cmp dx,ax
            jng coubou22b
            add cx,addo
            cmp cx,y3
            jng coubou2b

coucou2b:












coufaces:  add  di,16        ;fin de la boucle !
           add  si,2
           cmp  di,16*maxfaces / 4         ;24
           jnb  finfaces
           jmp  contface

finfaces:  ret
afffaces   endp


;-----------------------------------------------------------------------------
;-- AFFtable:affiches la table du jeu

Afftable    proc near
           
           mov  di,0
debaffplan:push di
           push di
           shl  di,1      ;multiplie di par 6   (3*2)
           mov  bx,di
           shl  bx,1
           add  di,bx

           mov  bx,[planche+di]
           mov  ax,[planche+di+2]
           mov  cx,[planche+di+4]
           call rotatx
           call rotaty                   ;cx---z
           push cx
           call convpt                   ; ax<y     bx<x
           pop  dx

           pop  di
;           shl  di,2
           shl  di,1
           shl  di,1

           mov  cx,di                    ;multiplie di par 12
           shl  cx,1                  
           add  di,cx


contfaces: mov si,word ptr [corresp+di]
           cmp si,0
           je okfaces

           shl  si,1                     ;mult si par 2          
           mov [faces+si],bx             ;modifie faces
           mov [faces+si+2],ax
           mov [profond+si],dx


           add di,2
           jmp contfaces


okfaces:   pop  di
           inc  di
           cmp  di,maxpts
           jnae  debaffplan

           call affpoly 
;           call afffaces

           ret
afftable   endp


;-----------------------------------------------------------------------------
;-- AFFPalet:affiches le Palet

AffPalet    proc near
           
           mov  di,0
           mov bx,0
debaffpal :
           push bx
           push di

           mov  bx,[palet+di]
           mov  ax,[palet+di+2]
           mov  cx,[palet+di+4]
           add bx,paletx
           add ax,palety
           call rotatx
           call rotaty                   ;cx---z
           call convpt                   ; ax<y     bx<x

           mov cx,bx
           pop di
           pop bx
           mov word ptr Palet2d[bx],ax
           mov word ptr Palet2d[bx+2],cx


           add di,6
           add bx,4

           cmp di,96     ;48*2    ;3*16*2
           jnge debaffpal
 

           mov di,0
contipal:
           mov  ax, palet2d[di]
           mov  bx, palet2d[di+2]
           mov  cx, palet2d[di+4]
           mov  dx, palet2d[di+6]
           push di
           call ligne
           pop di
           add di,4
           cmp di,60
           jnge contipal


           ret
affPalet   endp

;-----------------------------------------------------------------------------
;-- TOURNTABL: Rotation de la table 3d via la souris

TournTabl  proc near

           mov  positx,320         ;init des posit x et y de la souris
           mov  posity,175
           mov  ax,04h                 
           mov  cx,320
           mov  dx,175
           int  33h

;           mov  ax,03h                  ;init des posit x et y de la souris
;           int  33h
;           mov  positx,cx
;           mov  posity,dx

cycltourn: mov  ax,03h                  ;cherche evenemt souris
           int  33h
           cmp  bx,1                    ;si bouton droit > fin
           je   pasfintour
           jmp  fintourn

pasfintour:
           push cx
           push dx
           push cx
           mov  ax,04h                  ;init des posit x et y de la souris
           mov  cx,320
           mov  dx,175
           int  33h

           pop  cx
           pop  dx
           cmp  dx,posity               ;si pas deplacement en y
           jne   conti3
           cmp  cx,positx
           jne  conti
           jmp  cycltourn

                                        ;si deplacement en y

conti3:    cmp  dx,posity
           jg   supy
           sub  dx,posity
           mov  ax,dx
           shl  ax,1
           add  anglex,ax
           jmp  okopy
supy:
           mov  ax,posity
           sub  ax,dx
           shl  ax,1
           sub  anglex,ax

okopy:     cmp anglex,0
           jnl oky0
           mov anglex,stopangle
oky0:      cmp anglex,stopangle
           jng okangly
           mov anglex,0

okangly:


conti:     pop  cx
           cmp  cx,positx               ;si pas deplacement en x
           je   conti2

                                        ;si deplacement en x

           cmp  cx,positx
           jg   supx
           sub  cx,positx
           mov  ax,cx
           shl  ax,1
           add  angley,ax
           jmp  okopx
supx:
           mov  ax,positx
           sub  ax,cx
           shl  ax,1
           sub  angley,ax

okopx:     cmp angley,0
           jnl okx0
           mov angley,stopangle
okx0:      cmp angley,stopangle
           jng okanglx
           mov angley,0

okanglx:



conti2:    mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet

           pop ax
           call showpage

           mov  positx,320
           mov  posity,175

           jmp  cycltourn

fintourn:                                      

           cmp  bx,2                    ; test si bouton droit appuye
           je   pasfinpers
           jmp  finpers
pasfinpers:
           push cx
           push dx
           push cx
           mov  ax,04h                  ;init des posit x et y de la souris
           mov  cx,320
           mov  dx,175
           int  33h

           pop  cx
           pop  dx
           cmp  dx,posity               ;si pas deplacement en y
           jne   conti34
           cmp  cx,positx
           jne  conti24
           jmp  cycltourn

                                        ;si deplacement en y

conti34:    cmp  dx,posity
           jg   supy4
           sub  dx,posity
           mov  ax,dx
           shl  ax,1
           add  Perspective,ax
           jmp  okopy4
supy4:
           mov  ax,posity
           sub  ax,dx
           shl  ax,1
           sub  Perspective,ax

okopy4:     cmp Perspective,200
           jnl oky04
           mov Perspective,200
oky04:      cmp Perspective,800
           jng okangly4
           mov Perspective,800

okangly4:  mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet

           pop ax
           call showpage

           mov  positx,320
           mov  posity,175

           jmp  cycltourn

conti24:
           mov  positx,320
           mov  posity,175
           jmp  cycltourn



finpers:
           cmp  bx,3                    ; test si deux boutons appuyes
           je   pasfindepl
           jmp  findepl
pasfindepl:
           push cx
           push dx
           push cx
           mov  ax,04h                  ;init des posit x et y de la souris
           mov  cx,320
           mov  dx,175
           int  33h

           pop  cx
           pop  dx
           cmp  dx,posity               ;si pas deplacement en y
           jne   conti35
           cmp  cx,positx
           jne  conti5
           jmp  cycltourn

                                        ;si deplacement en y

conti35:    cmp  dx,posity
           jg   supy5
           sub  dx,posity
           mov  ax,dx
           shl  ax,1
           add  centery,ax
           jmp  okopy5
supy5:
           mov  ax,posity
           sub  ax,dx
           shl  ax,1
           sub  centery,ax

okopy5:     cmp centery,-350
           jnl oky05
           mov centery,-350
oky05:      cmp centery,700
           jng okangly5
           mov centery,700

okangly5:


conti5:     pop  cx
           cmp  cx,positx               ;si pas deplacement en x
           je   conti25

                                        ;si deplacement en x

           cmp  cx,positx
           jg   supx5
           sub  cx,positx
           mov  ax,cx
           shl  ax,1
           add  centerx,ax
           jmp  okopx5
supx5:
           mov  ax,positx
           sub  ax,cx
           shl  ax,1
           sub  centerx,ax

okopx5:     cmp centerx,-640
           jnl okx05
           mov centerx,-640
okx05:      cmp centerx,1280
           jng okanglx5
           mov centerx,1280

okanglx5:



conti25:    mov  ax,pagecour             ;actu de la page
           not  ax
           and  ax,1b
           mov  pagecour,ax
           push ax
           call setpage
           call efface
           call afftable
           call affpalet

           pop ax
           call showpage

           mov  positx,320
           mov  posity,175

           jmp  cycltourn




findepl:    ret

TournTabl  endp

;-----------------------------------------------------------------------------
;-- INIT640350: initialise le mode graphique EGA 640*350 en 16 couleurs

init640350 proc near

           mov   al,10h                            ;Installe le mode 10h
           mov   cx, 28000 / 16                       ;Offset de la page

init16:    mov   bx,640/8                           ;Largeur de la ligne

init:      mov   largeurl,bx                        ;Mmorise la largeur
           mov   pageofs,cx   ;Mmorise offset de page pour adr. de seg.

           xor   ah,ah               ;Appelle la fonction 00h pour fixer
           int   10h                                            ;le mode

           mov   vio_seg,0A000h     ;Fixe le segment de la mmoire cran
           ret                                             ;Rend la main

init640350 endp                                     ;Fin de la procdure

;-----------------------------------------------------------------------------
;-- SETPIX: Dessine un pixel dans une couleur donne
;-- Appel depuis TP: setpix( x , y : integer; couleur : byte );
;--ax:y  ;bx:x  ;couleur:couleur
setpix     proc near

       cmp  ax,0
       jl   finpix
       cmp  ax,349
       jg   finpix
       cmp  bx,0
       jl   finpix
       cmp  bx,639
       jg  finpix


  ;--Calcule d'abord l'offset en mmoire d'cran et le dcalage       --

       mov   dx,largeurl              ;Multiplie par la largeur de ligne
       mul   dx
       mov   cl,bl                ;Mmorise l'octet faible pour dcalage

;       shr   bx,3                             ;Divise l'abscisse X par 8
       shr   bx,1
       shr   bx,1
       shr   bx,1
       add   bx,ax                ;Ajoute offset provenant de la multipl

       and   cl,7                  ;Calcule masque binaire  partir de X
       xor   cl,7
       mov   ah,1
       shl   ah,cl

       mov   dx,GC_INDEX                 ;Accde au contrleur graphique
       mov   al,GC_BIT_MASK       ;Charge masque bin. dans reg. masquage
       out   dx,ax

       mov   ax,(02h shl 8) + GC_GRAPH_MODE              ;mode Write 2 &
       out   dx,ax                                          ;mode Read 0

       mov   ax,vio_seg            ;Charge en ES le segment de mm cran
       mov   es,ax                                         ;avec la page

       mov   al,es:[bx]                        ;Charge le registre latch
       mov   al,byte ptr couleur         ;Fixe la couleur du point
       mov   es:[bx],al                  ;Rcrit dans le registre latch

           ;-- Rtablit les valeurs par dfaut dans les registres du  --
                           ;-- contrleur graphqiue qui ont t modifis

       mov   ax,(0FFh shl 8 ) + GC_BIT_MASK
       out   dx,ax

       mov   ax,(00h shl 8) + GC_GRAPH_MODE
       out   dx,ax

finpix:ret                                ;Retire les paramtres de la pile

setpix     endp                                        ;Fin de procdure

;-----------------------------------------------------------------------------
;-- EFFACE : EFFACE la page concerne par les appels aux fonctions

efface  proc near

   mov ax, vio_seg      ;{met $a000 dans ax                      }
   mov es, ax           ;{met ax dans es, donc $a000 dans es car }
                        ;{on n'a pas le droit d'addresser es     }
                        ;{directement.                           }
   mov di, 0            ;{di = 0                                 }
   mov ax, 0            ;{ax = 0                                 }
   mov cx, 14000        ;{cx = 14000                             }
   rep stosw            ;{repete cx-fois stosw                   }
                        ;{or stosw fait : Mov [es:di],ax         }
                        ;{                add di,2               }
                        ;{toute la mmoire de di=0  di=32000*2  }
                        ;{est mise  0.                          }
   ret
efface  endp
;-----------------------------------------------------------------------------
;-- SETPAGE : Slectionne la page concerne par les appels aux fonctions
;--           setpix et getpix
;-- Appel depuis TP: setpage( page : byte );
;-- ax:page
setpage    proc near

       mul   pageofs        ;Multiplie numro de page par offset de page

       add   ax,0A000h                        ;Ajoute le segment de base
       mov   vio_seg,ax            ;Mmorise la nouvelle adr. de segment

       ret                            ;Retourne  l'appelant, l'argument
                                       ;ayant dj t retir de la pile

setpage    endp                                     ;Fin de la procdure

;-----------------------------------------------------------------------------
;-- SHOWPAGE : Affiche l'une des pages d'cran disponibles
;-- Appel depuis TP: showpage( page : byte );
;-- ax:page
showpage   proc near

       mul   pageofs        ;Multiplie le numro de la page par l'offset
       mov   cl,4                          ;de la page et le tout par 16
       shl   ax,cl

       mov   bl,al                     ;Mmorise l'octet de poids faible

       mov   dx,CRTC_INDEX                ;Adresse le contrleur d'cran
       mov   al,CC_START_HI                ;Affiche d'abord l'octet fort
       out   dx,ax
       inc   al                                     ;puis l'octet faible
       mov   ah,bl
       out   dx,ax

                 ;-- Attend le dbut d'un rafrachissement d'cran -----

       mov   dx,VERT_RETRACE         ;Attend la fin du balayage vertical
sp3:   in    al,dx
       test  al,8
       jne   sp3

sp4:   in    al,dx                  ;puis le dbut du retour du faisceau
       test  al,8
       je    sp4

       ret                                        ;Retourne  l'appelant

showpage   endp                                     ;Fin de la procdure





code       ends

;== Stack ==============================================================

pile       segment para stack 'stack'
           dw 256 dup(?)
pile       ends

;== Fin ================================================================

end        debut
